using UnityEngine;using System.Collections.Generic;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using System.Linq;using Battlehub.RTCommon;namespace PluginIdea{    public class GizmosSystem : MVRScript, IGL    {        public const string InputModule = "InputModule";        public const string HudHanderModule = "HudHanderModule";        public const string MeshDrawModule = "MeshDrawModule";        public const string LightDrawModule = "LightDrawModule";        public const string CameraDrawModule = "CameraDrawModule";        public const string PersonDrawModule = "PersonDrawModule";        public const string AudioSourceDrawModule = "AudioSourceDrawModule";        public const string FreeControllerModule = "FreeControllerModule";        public JSONStorableBool isDrawMesh;        public JSONStorableBool isDrawLight;        public JSONStorableBool isDrawCamera;        public JSONStorableBool isDrawFreeController;        public JSONStorableBool isPerson;        public JSONStorableBool isAudioSource;        private JSONStorableStringChooser cameraChoosser;        private Dictionary<string, GZModuleBase> uid2Modules = new Dictionary<string, GZModuleBase>();        private Dictionary<string, Mesh> dic_Meshs = new Dictionary<string, Mesh>();        private List<string> meshnames = new List<string> { "arm", "chest", "enbow", "foot", "hand", "head", "knee", "pelvis" };        private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();        private Dictionary<string, Camera> dic_name2Camera = new Dictionary<string, Camera>();        private Atom currentSelectedAtom;        private Camera currentSelectedCamera;        public Camera CurrentSelectedCamera        {            get            {                return currentSelectedCamera;            }        }        public Atom CurrentDrawAtom        {            get {                return this.currentSelectedAtom;            }        }        public Dictionary<string, Shader> Dic_BundleShaders        {            get {                return this.dic_BundleShaders;            }        }        public Dictionary<string, Mesh> Dic_Meshes        {            get {                return this.dic_Meshs;            }        }        public Transform CenterCameraTrans        {            get            {                if (Utils.IsInVR())                {                    if (SuperController.singleton.isOpenVR)                    {                        return SuperController.singleton.ViveCenterCamera.transform;                    }                    return SuperController.singleton.OVRCenterCamera.transform;                }                else                {                    return SuperController.singleton.MonitorCenterCamera.transform;                }            }        }        public override void Init()        {            base.Init();            ResourceInit();        }        private void DelayInit()        {            DataInit();            UIInit();            EventInit();            LogicInit();        }        private void ResourceInit()        {            string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/gzsystem.assetbundle";            Request request = new Request { path = assetsBundlePath, callback = OnAssetBundleLoaded };            AssetLoader.QueueLoadAssetBundleFromFile(request);        }        private void OnAssetBundleLoaded(Request request)        {            Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();            for (int i = 0; i < shaders.Length; i++)            {                SuperController.LogMessage("Shader: " + shaders[i].name);                if (!dic_BundleShaders.ContainsKey(shaders[i].name))                {                    dic_BundleShaders.Add(shaders[i].name, shaders[i]);                }            }            meshnames.ForEach(n => {                GameObject gb = request.assetBundle.LoadAsset<GameObject>(n);                SuperController.LogMessage(gb.name);                Mesh mesh = gb.GetComponentInChildren<MeshFilter>().sharedMesh;                dic_Meshs.Add(n, mesh);            });            DelayInit();        }                private void DataInit()        {        }        private void UIInit()        {            isDrawMesh = Utils.SetupToggle(this, "Is DrawMesh Topology", true, false);            isDrawLight = Utils.SetupToggle(this, "Is Draw Light", true, false);            isDrawFreeController = Utils.SetupToggle(this, "Is Draw Diff Color", true, false);                                    isAudioSource = Utils.SetupToggle(this, "Is Draw AudioSource", true, false);                                }        private void EventInit()        {            RegisterModule(InputModule, new InputModule(this));                        RegisterModule(MeshDrawModule, new MeshDrawMoudle(this));            RegisterModule(LightDrawModule, new LightDrawModule(this));            RegisterModule(PersonDrawModule, new PersonDrawModule(this));            RegisterModule(AudioSourceDrawModule, new AudioSourceDrawModule(this));            RegisterModule(FreeControllerModule, new FreeControllerModule(this));                                                            isDrawMesh.setCallbackFunction = (val) => {                uid2Modules[MeshDrawModule].EnableDraw(val);            };            isDrawFreeController.setCallbackFunction = (val) => {                uid2Modules[FreeControllerModule].EnableDraw(val);            };        }        private void LogicInit()        {                    }        private void Start()        {            if (GLRenderer.Instance == null)            {                new GameObject                {                    name = "GLRenderer"                }.AddComponent<GLRenderer>();            }            GLRenderer.Instance.Add(this);        }                private void Update()        {            currentSelectedAtom = SuperController.singleton.GetSelectedAtom();                        foreach (var module in uid2Modules.Values.ToList())            {                module.OnUpdate();            }        }        private void RegisterModule(string key, GZModuleBase module)        {            if (!uid2Modules.ContainsKey(key))            {                uid2Modules.Add(key, module);                module.Init();            }        }        private void UnRegisterModule(string key)        {            if (uid2Modules.ContainsKey(key))            {                uid2Modules[key].UnInit();                uid2Modules.Remove(key);            }        }        private void OnDestroy()        {            if (uid2Modules.Count > 0)            {                foreach (var key in uid2Modules.Keys.ToList())                {                    UnRegisterModule(key);                }                uid2Modules.Clear();            }            GLRenderer.Instance.Remove(this);        }        public void Draw(int cullingMask)        {            foreach (var module in uid2Modules.Values.ToList())            {                module.OnPostRender();            }        }    }}