using UnityEngine;using System.Collections.Generic;using UnityEngine.UI;namespace PluginIdea{    public class FreeControllerModule : GZModuleBase    {        private List<Color> colors = new List<Color> {                        new Color(0,1,0),            new Color(0,0,1),            new Color(1,0,1),            new Color(1,1,1),            new Color(0,1,1),            new Color(1,1,0),            new Color(0.5f,0.5f,0),             new Color(0,0.7f,0.5f),             new Color(0,0.75f,0),        };        private Color defaultOnColor = Color.green;        private bool isDraw;        int index = 0;        public FreeControllerModule(GizmosSystem ower)        {            this.ower = ower;            SuperController.singleton.onAtomAddedHandlers += OnAtomAdded;            SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;        }        public override void EnableDraw(bool val)        {            this.isDraw = val;            RefreshV3Color();        }        public override void Init()        {            this.isDraw = ower.isDrawFreeController.val;            RefreshV3Color();        }        private void RefreshV3Color()        {            SuperController.singleton.GetAtoms().ForEach(atom =>            {                SetAtomControllerV3Color(atom);            });        }        private void SetAtomControllerV3Color(Atom atom)        {            index++;            if (index == colors.Count) index = 0;            Color rc = isDraw ? colors[index] : defaultOnColor;            atom.freeControllers.ToList().ForEach(v3 =>            {                v3.onColor = rc;                v3.highlighted = false;                SuperController.LogMessage(v3.name + " " + v3.deselectedMeshScale.ToString());                if (isDraw && atom.type == "Person")                {                    switch (v3.name)                    {                        case "chestControl":                            v3.deselectedMesh = ower.Dic_Meshes["chest"];                            break;                        case "headControl":                            v3.deselectedMesh = ower.Dic_Meshes["head"];                            break;                        case "rHandControl":                        case "lHandControl":                            v3.deselectedMesh = ower.Dic_Meshes["hand"];                            break;                        case "rFootControl":                        case "lFootControl":                            v3.deselectedMesh = ower.Dic_Meshes["foot"];                            break;                        case "rElbowControl":                        case "lElbowControl":                            v3.deselectedMesh = ower.Dic_Meshes["enbow"];                            break;                        case "rKneeControl":                        case "lKneeControl":                            v3.deselectedMesh = ower.Dic_Meshes["knee"];                            break;                        case "rArmControl":                        case "lArmControl":                            v3.deselectedMesh = ower.Dic_Meshes["arm"];                            break;                        case "penisBaseControl":                        case "penisMidControl":                        case "penisTipControl":                            v3.deselectedMesh = ower.Dic_Meshes["pelvis"];                            break;                    }                }            });        }        private void OnAtomAdded(Atom atom)        {            SetAtomControllerV3Color(atom);        }        private void OnSceneLoaded()        {            RefreshV3Color();        }                    public override void UnInit()        {            SuperController.singleton.onAtomAddedHandlers -= OnAtomAdded;            SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;        }    }}