using UnityEngine;using System.Collections.Generic;using UnityEngine.UI;namespace PluginIdea{    public class MeshDrawMoudle : GZModuleBase    {        private JSONStorableColor wireColor;        private JSONStorableFloat wireAlpha;        private List<Renderer> effectiveMrs = new List<Renderer>();        private Atom lastSelectedAtom;        private bool isOnDraw;        private float Alpha        {            set {                if (isOnDraw && effectiveMrs.Count > 0)                    effectiveMrs.ForEach(mr => {                        Material tmpMat = mr.materials[mr.materials.Length - 1];                        Color color = new Color(tmpMat.color.r, tmpMat.color.g, tmpMat.color.b, value);                        tmpMat.SetColor("_Color", color);                    });            }        }        private Color Color        {            set {                if (isOnDraw && effectiveMrs.Count > 0)                {                    effectiveMrs.ForEach(mr => {                        Material tmpMat = mr.materials[mr.materials.Length - 1];                        tmpMat.SetColor("_Color", value);                    });                }            }        }        public MeshDrawMoudle(GizmosSystem ower)        {            this.ower = ower;        }        public override void EnableDraw(bool val)        {            SetIsDraw(val);        }        public override void Init()        {            Utils.SetupSpacer(ower, 50, false);            wireAlpha = Utils.SetupSliderFloat(ower, "Wire Topology Alpha", 1f, 0f, 1f, false);            wireColor = Utils.SetupColor(ower, "Wire Topology Color", Color.white, true);            wireAlpha.setCallbackFunction = (val) => { Alpha = val; };            wireColor.setCallbackFunction = (h, s, v) => { Color = Color.HSVToRGB(h, s, v); };        }        public override void OnUpdate()        {            base.OnUpdate();            if (ower.CurrentDrawAtom.type == "Person") return;            if (ower.CurrentDrawAtom != null && ower.CurrentDrawAtom != lastSelectedAtom)            {                if (ower.isDrawMesh.val)                {                    DrawAtom(ower.CurrentDrawAtom);                }                else                lastSelectedAtom = ower.CurrentDrawAtom;            }        }        public void DrawAtom(Atom atom)        {                        if (isOnDraw) SetIsDraw(false);            atom.GetComponentsInChildren<Renderer>(effectiveMrs);                        SetIsDraw(true);        }        private void SetIsDraw(bool isDraw)        {            if (effectiveMrs.Count > 0)            {                isOnDraw = isDraw;                effectiveMrs.ForEach(r =>                {                    if (isDraw)                    {                        List<Material> tmpMats = r.materials.ToList();                        Material tmpMat = new Material(ower.Dic_BundleShaders["GeoShader/Line"]);                        tmpMat.color = Color.HSVToRGB(wireColor.val.H, wireColor.val.S, wireColor.val.V);                        tmpMat.color = new Color(tmpMat.color.r, tmpMat.color.g, tmpMat.color.b, wireAlpha.val);                        tmpMats.Add(tmpMat);                        r.materials = tmpMats.ToArray();                    }                    else                    {                        List<Material> tmpMats = r.materials.ToList();                        tmpMats.RemoveAt(tmpMats.Count - 1);                        r.materials = tmpMats.ToArray();                    }                });            }        }        public override void UnInit()        {            if (ower.CurrentDrawAtom.type != "Person")            {                SetIsDraw(false);            }        }    }}